# Rust AWS Lambda and Step Functions

[![pipeline status](https://gitlab.com/dukeaiml/IDS721/rg361_ind_4/badges/main/pipeline.svg)](https://gitlab.com/dukeaiml/IDS721/rg361_ind_4/-/commits/main)

## 1. Overview
In this project, we will demonstrate the use of ``Step Funtion`` in AWS by using it to manage the excution of 2 ``Lambda functions`` built using ``Rust`` which interact with a ``DynamoDB`` table.

please watch this [Video](https://youtu.be/kEjp3siFFho) for a quick overview and demo of the project.

## 2. Project Development

### 2.1. Lambda Functions

To demostrate the use of step functions, we used two lambda fuctions in this project:
- step_1: This function when triggered, generates a random number and inserts it into a dynamoDB table, it then returns the generated number.
- step_2: This function when triggered, access the dynamoDB table and returns the total number of items in the table.

These two function are written in Rust and are to simulate the real-world use case of a step function, step funtions can be used to manage any number of lambda functions and other AWS services.

It is helpful if the Response of the preceeding lambda function is the same as the input of the next lambda function, this way the output of one function can be used as the input of the next function directly. else we can use the step function to manage the input and output of each lambda function.

Below are the instructions for building and deploying the lambda functions. refer to the code present in the ``src`` directory of each lambda function for the implementation details.

1. Create a new cargo lambda project using the following command:
```bash
cargo lambda new <function_name>
```

2. Enter the code in the ``src/main.rs`` file of the newly created project. and add the required dependencies in the ``Cargo.toml`` file.

3. Build the project using the following command:
```bash
cargo lambda build
```

4. Perform local testing of the lambda function using the following commands, each in a separate terminal with required arguments:
```bash
cargo lambda watch
cargo lambda invoke 
```

5. Once verified, deploy to AWS using the following command, make sure to provide the function the required permissions:
```bash
cargo lambda build --release
cargo lambda deploy --iam-role <role_arn>
```
Example:  
![Deploy Lambda](resources/lam_deploy.png)

6. The lambda function is now deployed and can be accessed from the AWS console.

7. Test the deployed lambda function
Example:  
![Test Lambda](resources/lam_test.png)

### 2.2. DynamoDB Table

Create a new DynamoDB table using the AWS console.

We make use of this simple DynamoDB table in this project to store the random numbers generated by the first lambda function. The second lambda function then reads the table and returns the total number of items in the table.

This table is for demonstration purposes and can be replaced with any other AWS service or external service as required.

**Note:** Make sure the role used by the lambda function has the required permissions to access this DynamoDB table.

### 2.3. Step Function

The step function can be used to manage the execution of multiple lambda functions and other AWS services in a specific order and can be used to create complex workflows.

Once the DynamoDB table and the lambda functions are created and tested, we can now create a step function to manage the execution of these lambda functions.

1. Create a new step function using the AWS console.
2. Add the lambda functions created above to the step function in the required order.
3. ensure the input and output of each lambda function are correctly configured.
![Step Function](resources/step_function.png)

## 3. Sample Execution
1. DynamoDB before execution:  
![DynamoDB before execution](resources/sample_exec_1.png)

2. Trigger the step function:
![Trigger the step function](resources/sample_exec_2.png)

3. Completion of step function:
![Completion of step function](resources/sample_exec_3.png)

4. Values from Lambda functions during execution:
![Values from Lambda functions during execution](resources/sample_exec_4.png)

5. DynamoDB after execution:
![DynamoDB after execution](resources/sample_exec_5.png)

## Gitlab CI/CD Pipeline

The project also has a Gitlab CI/CD pipeline which automatically performs Formatting, Linting, building etc. when a new commit is pushed to the repository.

![Gitlab CI/CD Pipeline](resources/cicd.png)

